質問をすることでしか得られない、回答やアドバイスがある。

15分調べてもわからないことは、質問しよう!

ただいまの
回答率

87.48%

Ubuntuでpipを実行するとエラーになる

解決済

回答 1

投稿 編集

  • 評価
  • クリップ 0
  • VIEW 2,459

score 11

概要

Ubuntuにてaptでインストールしたpython-pipをpipコマンドでアップグレードしたら環境が壊れました。
aptのremoveでpipをアンインストールしても、pipコマンドが実行できてしまうため、
いったんpipを完全にアンインストールしたいです。何か方法はないでしょうか。

きっかけ

awsコマンドでエラーが出るようになり、バックアップのコマンドが失敗していることに気づきました。
(いつからエラーが出るようになったかは不明)

aws --version
Traceback (most recent call last):
  File "/usr/local/bin/aws", line 19, in <module>
    import awscli.clidriver
  File "/usr/local/lib/python2.7/dist-packages/awscli/clidriver.py", line 26, in <module>
    from awscli.formatter import get_formatter
  File "/usr/local/lib/python2.7/dist-packages/awscli/formatter.py", line 19, in <module>
    from awscli.table import MultiTable, Styler, ColorizedStyler
  File "/usr/local/lib/python2.7/dist-packages/awscli/table.py", line 18, in <module>
    import colorama
ImportError: No module named colorama
awscliのアップグレード

そこでpipでアップグレードを行いました。

>sudo pip install awscli --upgrade --user
=省略=
Successfully installed PyYAML-3.11 awscli-1.11.34 botocore-1.4.91 colorama docutils-0.13.1 futures-3.0.5 jmespath-0.9.0 pyasn1-0.1.9 python-dateutil-2.6.0 rsa-3.4.2 s3transfer-0.1.10 six-1.10.0 urllib3-1.13.1
You are using pip version 8.1.1, however version 21.0.1 is available.
You should consider upgrading via the 'pip install --upgrade pip' command.
pipのアップグレード

awsコマンドのエラーは変わらなかったため、アップグレードのメッセージの通りpipのアップグレードを行いました。

>pip install --upgrade pip
=省略=
Successfully built pip


コマンド実行は成功したものの、これを行ったことによりpipコマンドで下記のエラーが出るようになってしまいました。

>pip
Traceback (most recent call last):
  File "/usr/local/bin/pip", line 7, in <module>
    from pip._internal.cli.main import main
  File "/usr/local/lib/python2.7/dist-packages/pip/_internal/cli/main.py", line 60
    sys.stderr.write(f"ERROR: {exc}")
                                   ^
SyntaxError: invalid syntax
試したこと

python-pipのアンインストールのため下記コマンドを実行した。
この結果/usr/bin/pipは削除されたものの、/usr/local/bin/pipは残っている。

>sudo apt --purge remove python-pip
>sudo apt autoremove


完全に削除したいので、下記コマンドを実行したが、pipコマンドが通らない。

>python -m pip uninstall pip
Traceback (most recent call last):
  File "/usr/lib/python2.7/runpy.py", line 174, in _run_module_as_main
    "__main__", fname, loader, pkg_name)
  File "/usr/lib/python2.7/runpy.py", line 72, in _run_code
    exec code in run_globals
  File "/usr/local/lib/python2.7/dist-packages/pip/__main__.py", line 21, in <module>
    from pip._internal.cli.main import main as _main
  File "/usr/local/lib/python2.7/dist-packages/pip/_internal/cli/main.py", line 60
    sys.stderr.write(f"ERROR: {exc}")
                                   ^
SyntaxError: invalid syntax
環境

Ubuntu 16.04.7 LTS
Python 2.7.12

参考にしたサイト

https://oji-cloud.net/2019/12/11/post-3734/
https://mem-archive.com/2018/10/28/post-996/
https://laboradian.com/cannot-import-name-main-when-upgrading-pip/

少しでも分かることがあれば教えてください。
よろしくお願いします。

  • 気になる質問をクリップする

    クリップした質問は、後からいつでもマイページで確認できます。

    またクリップした質問に回答があった際、通知やメールを受け取ることができます。

    クリップを取り消します

  • 良い質問の評価を上げる

    以下のような質問は評価を上げましょう

    • 質問内容が明確
    • 自分も答えを知りたい
    • 質問者以外のユーザにも役立つ

    評価が高い質問は、TOPページの「注目」タブのフィードに表示されやすくなります。

    質問の評価を上げたことを取り消します

  • 評価を下げられる数の上限に達しました

    評価を下げることができません

    • 1日5回まで評価を下げられます
    • 1日に1ユーザに対して2回まで評価を下げられます

    質問の評価を下げる

    teratailでは下記のような質問を「具体的に困っていることがない質問」、「サイトポリシーに違反する質問」と定義し、推奨していません。

    • プログラミングに関係のない質問
    • やってほしいことだけを記載した丸投げの質問
    • 問題・課題が含まれていない質問
    • 意図的に内容が抹消された質問
    • 過去に投稿した質問と同じ内容の質問
    • 広告と受け取られるような投稿

    評価が下がると、TOPページの「アクティブ」「注目」タブのフィードに表示されにくくなります。

    質問の評価を下げたことを取り消します

    この機能は開放されていません

    評価を下げる条件を満たしてません

    評価を下げる理由を選択してください

    詳細な説明はこちら

    上記に当てはまらず、質問内容が明確になっていない質問には「情報の追加・修正依頼」機能からコメントをしてください。

    質問の評価を下げる機能の利用条件

    この機能を利用するためには、以下の事項を行う必要があります。

質問への追記・修正、ベストアンサー選択の依頼

  • meg_

    2021/02/06 21:12

    > この結果/usr/bin/pipは削除されたものの、/usr/local/bin/pipは残っている。
    pip -Vとかwhich pipで「pip install --upgrade pip」でインストールしたpipが表示される状態でしょうか?
    そうであればpathから削除するのはどうでしょうか?
    不要でありどうしても削除したいなら直接コマンドで消せば良いかと思いますし、あっても問題ないのであればそのまま残しておいても良いかと思います。(python2.7のことは詳しくないですし、質問者さんがどのコマンドを実行して、どのパスに何をインストール&アンインストールしたのか詳細が分からないので自己責任でお願いします。)

    キャンセル

  • nok123

    2021/02/07 19:12

    meg様
    助言ありがとうございます。
    確かに、不要なファイルを削除してしまえば良いですね。
    いったんすべてのpip関連のファイルを削除してみました。
    その後、aptでインストールしたpipは今後もpipでアップグレードしないよう、気を付けます。
    awscliもインストールし直し、エラーが出なくなったので実行したコマンド等は解決方法に記載しておきます。

    キャンセル

  • nok123

    2021/02/07 19:13

    ppaul様
    コメントありがとうございました。
    今後このような質問をする際はバージョン情報に漏れがないよう気を付けます。

    キャンセル

回答 1

check解決した方法

0

いったんpip、awscliを削除し、入れなおしたところエラーが発生しなくなりました。
実行したコマンドは下記の通りです。


●aptインストールしたpipのアンインストール
>sudo apt --purge remove python-pip
>sudo apt autoremove
●不要なpip関連のライブラリと実行ファイル削除
>sudo rm -rf /usr/local/lib/python2.7/
>sudo rm -rf /usr/local/bin/pip
>sudo rm -rf /usr/local/bin/pip2
>sudo rm -rf /usr/local/bin/pip2.7
●pip再インストール
>sudo apt install python-pip
●pipコマンド確認
>pip list


●awscliアンインストール
>sudo rm /usr/local/bin/aws
>sudo rm /usr/local/bin/aws_completer
>sudo rm -rf /usr/local/aws-cli
●awscli再インストール
>curl "https://s3.amazonaws.com/aws-cli/awscli-bundle.zip" -o "awscli-bundle.zip"
>unzip awscli-bundle.zip
>sudo ./awscli-bundle/install -i /usr/local/aws -b /usr/local/bin/aws
●awsコマンド確認
>aws --version
aws-cli/1.19.3 Python/2.7.12 Linux/3.13.0-61-generic botocore/1.20.3

投稿

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

15分調べてもわからないことは、teratailで質問しよう!

  • ただいまの回答率 87.48%
  • 質問をまとめることで、思考を整理して素早く解決
  • テンプレート機能で、簡単に質問をまとめられる

関連した質問

同じタグがついた質問を見る